Subject: Re: bug#43735: 28.0.50; eshell: No such directory found via CDPATH environment variable

From: Jean Louis <[email-masked]>
Date: Sat, 14 Nov 2020 10:16:57 +0300

* Jean Louis <[email-masked]> [2020-11-14 02:14]:
> * Lars Ingebrigtsen <[email-masked]> [2020-10-02 00:56]:
> > Jean Louis <[email-masked]> writes:
> > 
> > > If you change within shell or eshell maybe no, I change it in .bashrc
> > > before launching and can reproduce reliably
> > 
> > My test case is
> > 
> > CDPATH="/var" emacs -Q
> > M-x eshell
> > $ cd tmp
> > /var/tmp $
> > 
> > So CDPATH works as advertised in eshell, as far as I can tell.
> 
> I have CDPATH defined in .bashrc
> 
> It is
> ":~:/home/data1/protected/Work/3rd-Dynamic/Corporation/Division_4/Dept_10/Company Formation"
> 
> Then I start: emacs -q
> 
> then: cd tmTAB it works, it expands to tmp and I enter tmp
> 
> Initially I am in directory /home/data1/protected
> 
> if I am in tmp, after cd .. I come back to /home/data1 instead of
> /home/data1/protected
> 
> then after cd .. if I wish to come back to home I can do cd ~ which
> works.

Another attempt to use Emacs shell where CDPATH is colliding with
eshell. Directory Software/ is there, it even expands by using TAB to
add the slash / on the end of word Software. So if it expands it does
find the directory, but then collides something with CDPATH

Welcome to the Emacs shell

~ $ cd Programming/
~/Programming $ cd Software/emacs/
No such directory found via CDPATH environment variable
~/Programming $ git pull
fatal: Not a git repository (or any parent up to mount point /home)
Stopping at filesystem boundary (GIT_DISCOVERY_ACROSS_FILESYSTEM not set).
~/Programming $ echo $CDPATH
./:~:/home/data1/protected/Work/3rd-Dynamic/Corporation/Division_4/Dept_10/Company Formation
~/Programming $ cd Software/
No such directory found via CDPATH environment variable
~/Programming $ ls 
BASIC      Gold     Perl6    RCDRUN                 TeX    emacs-lisp  hexadecimal   perl5
Documents  Haskell  Phone    Scheme                 c      git         languages     services
Forth      Lisp     Privacy  Software               clisp  groff       love          templeos
GNU        Perl     R        System Administration  dict   guile       peg-markdown  
~/Programming $
~/Programming $ unset CDPATH
~/Programming $ cd Software/
No such directory found via CDPATH environment variable
~/Programming $ 
~/Programming $ file Software/
Software/: directory